---
updatedAt: 2026-04-26T17:18:55.000Z
agentTools:
  projectIndex: https://docs.d-id.com/llms.txt
---

# Create a Video

# OpenAPI definition

```json
{
  "openapi": "3.0.3",
  "info": {
    "title": "Videos Endpoints",
    "version": "0.1"
  },
  "servers": [
    {
      "url": "https://api.d-id.com/"
    }
  ],
  "paths": {
    "/expressives": {
      "post": {
        "operationId": "Create3",
        "responses": {
          "201": {
            "description": "Created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateExpressiveResponseDto"
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "id": "52907745-7672-470e-a803-a2f8feb52944",
                      "object": "expressive",
                      "created_at": "2020-09-03T13:56:54.995",
                      "status": "created"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "BadRequestError | InvalidFileSizeError",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/JsonError"
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "kind": "BadRequestError",
                      "description": "no found"
                    }
                  }
                }
              }
            }
          },
          "401": {
            "description": "AuthorizationError",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/JsonError"
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "kind": "AuthorizationError",
                      "description": "user unauthenticated"
                    }
                  }
                }
              }
            }
          },
          "402": {
            "description": "InsufficientCreditsError",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/JsonError"
                },
                "examples": {
                  "Example 1": {
                    "value": {
                      "kind": "InsufficientCreditsError",
                      "description": "not enough credits"
                    }
                  }
                }
              }
            }
          }
        },
        "summary": "Create a Video",
        "tags": [
          "V4 Avatars"
        ],
        "security": [
          {
            "basic": []
          },
          {
            "bearer": []
          }
        ],
        "parameters": [
          {
            "in": "header",
            "name": "x-api-key-external",
            "required": false,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Flatten_Pick_ExpressiveVideo.avatar_id-or-sentiment_id-or-name-or-config-or-background-or-user_data-or-persist-or-result_url-or-webhook-or-internal_call_config_-and-_script-Script__"
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "JsonError": {
        "properties": {
          "kind": {
            "type": "string"
          },
          "description": {
            "type": "string"
          },
          "details": {},
          "internal": {
            "type": "string"
          }
        },
        "required": [
          "kind",
          "description"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "Providers.Microsoft": {
        "enum": [
          "microsoft"
        ],
        "type": "string"
      },
      "VoiceConfigMicrosoft": {
        "properties": {
          "style": {
            "type": "string",
            "description": "The style of the voice.\nAvailable styles change between voices."
          },
          "rate": {
            "type": "string",
            "description": "The speed of the voice.\nThe value is relative to 1, 0.5 being half speed, 2 being twice as fast, etc.\nAnother option is a constant value from x-slow/slow/medium/fast/x-fast.\nNot supported for azure-openai voices, which reject it with a 400 error.",
            "example": "0.5"
          },
          "pitch": {
            "type": "string",
            "description": "The pitch of the voice.\nValue could be an absolute value in Hz (including units), a relative value in Hz or st(semitones)\nor a constant value from x-low/low/medium/high/x-high.",
            "example": "+2st"
          }
        },
        "type": "object",
        "additionalProperties": false
      },
      "Microsoft_tts_provider": {
        "properties": {
          "type": {
            "$ref": "#/components/schemas/Providers.Microsoft"
          },
          "voice_id": {
            "type": "string",
            "description": "Voice ID selected from the list of available voices.</br>Retrieve available options from the GET /voices endpoint.",
            "example": "en-US-JennyNeural"
          },
          "voice_config": {
            "$ref": "#/components/schemas/VoiceConfigMicrosoft",
            "description": "Voice customization options"
          },
          "language": {
            "type": "string",
            "description": "Voice customization options. To save the language of the selected agent voice",
            "example": "English (United States)"
          }
        },
        "required": [
          "type",
          "voice_id"
        ],
        "type": "object",
        "additionalProperties": false,
        "title": "Microsoft"
      },
      "Providers.Elevenlabs": {
        "enum": [
          "elevenlabs"
        ],
        "type": "string"
      },
      "VoiceConfigElevenlabs": {
        "properties": {
          "stability": {
            "type": "number",
            "format": "double",
            "description": "How stable the voice is and the randomness of each new generation.\nIf ElevenLabs V3 model is selected, must be one of these values: 0.0, 0.5, 1.0 (0.0 = Creative, 0.5 = Natural, 1.0 = Robust).",
            "example": "0",
            "minimum": 0,
            "maximum": 1
          },
          "similarity_boost": {
            "type": "number",
            "format": "double",
            "description": "The similarity slider dictates how closely the AI should adhere to the original voice when attempting to replicate it.",
            "example": "0",
            "minimum": 0,
            "maximum": 1
          },
          "rate": {
            "type": "string",
            "description": "The speed of the voice.\nThe value is relative to 1. Valid range is 0.7 to 1.2.",
            "example": "0.7",
            "pattern": "^(|0\\.[7-9][0-9]*|1(\\.[0-1][0-9]*|\\.2|\\.20*)?)$"
          },
          "style": {
            "type": "string",
            "description": "Determines the style exaggeration of the voice.\nThis setting attempts to amplify the style of the original speaker.\nIt does consume additional computational resources and might increase latency if set to anything other than 0.\nValid range is 0 to 1.",
            "example": "0.5",
            "pattern": "^(|0(\\.[0-9]+)?|1(\\.0+)?)$"
          },
          "use_speaker_boost": {
            "type": "boolean",
            "description": "boosts the similarity to the original speaker.\nUsing this setting requires a slightly higher computational load, which in turn increases latency.",
            "example": true
          },
          "apply_language_text_normalization": {
            "type": "boolean",
            "description": "Controls language text normalization. This helps with proper pronunciation of text in some supported languages.\nWARNING: This parameter can heavily increase the latency of the request. Currently only supported for Japanese.",
            "example": true
          },
          "apply_text_normalization": {
            "type": "string",
            "enum": [
              "auto",
              "on",
              "off"
            ],
            "description": "Controls text normalization on the ElevenLabs side (expanding numbers, abbreviations and symbols).\n'auto' lets ElevenLabs decide, 'on' forces normalization, 'off' disables it.\nDefaults to 'off' when not provided.",
            "example": "off"
          }
        },
        "type": "object",
        "additionalProperties": false
      },
      "Elevenlabs_tts_provider": {
        "properties": {
          "type": {
            "$ref": "#/components/schemas/Providers.Elevenlabs"
          },
          "voice_id": {
            "type": "string",
            "description": "Voice ID selected from the list of available voices.</br>Retrieve available options from the GET /voices endpoint.",
            "example": "21m00Tcm4TlvDq8ikWAM",
            "default": "21m00Tcm4TlvDq8ikWAM"
          },
          "voice_config": {
            "$ref": "#/components/schemas/VoiceConfigElevenlabs",
            "description": "Voice customization options. Read more here: https://docs.elevenlabs.io/speech-synthesis/voice-settings"
          },
          "model_id": {
            "type": "string",
            "description": "The model id from the list of available models. https://elevenlabs.io/docs/speech-synthesis/models.",
            "example": "eleven_multilingual_v2",
            "default": "eleven_multilingual_v2"
          },
          "language": {
            "type": "string",
            "description": "Voice customization options. To save the language of the selected voice",
            "example": "English (United States)"
          }
        },
        "required": [
          "type"
        ],
        "type": "object",
        "additionalProperties": false,
        "title": "ElevenLabs"
      },
      "Providers.Amazon": {
        "enum": [
          "amazon"
        ],
        "type": "string"
      },
      "VoiceIdsAmazon": {
        "type": "string",
        "enum": [
          "Amy",
          "Aria",
          "Ayanda",
          "Bianca",
          "Brian",
          "Camila",
          "Emma",
          "Gabrielle",
          "Ivy",
          "Joanna",
          "Joey",
          "Justin",
          "Kendra",
          "Kevin",
          "Kimberly",
          "Léa",
          "Lucia",
          "Lupe",
          "Matthew",
          "Olivia",
          "Salli",
          "Seoyeon",
          "Takumi",
          "Vicki"
        ],
        "nullable": false
      },
      "Amazon_tts_provider": {
        "properties": {
          "type": {
            "$ref": "#/components/schemas/Providers.Amazon"
          },
          "voice_id": {
            "$ref": "#/components/schemas/VoiceIdsAmazon",
            "description": "Voice ID selected from the list of available voices.</br>Retrieve available options from the GET /voices endpoint.",
            "example": "Joanna"
          },
          "language": {
            "type": "string",
            "description": "Voice customization options. To save the language of the selected agent voice",
            "example": "English (United States)"
          }
        },
        "required": [
          "type",
          "voice_id"
        ],
        "type": "object",
        "additionalProperties": false,
        "title": "Amazon"
      },
      "Providers.Google": {
        "enum": [
          "google"
        ],
        "type": "string"
      },
      "Google_tts_provider": {
        "properties": {
          "type": {
            "$ref": "#/components/schemas/Providers.Google"
          },
          "voice_id": {
            "type": "string",
            "description": "Voice ID selected from the list of available voices.</br>Retrieve available options from the GET /voices endpoint.",
            "example": "he-IL-Wavenet-A",
            "default": "he-IL-Wavenet-A"
          }
        },
        "required": [
          "type"
        ],
        "type": "object",
        "additionalProperties": false,
        "title": "Google"
      },
      "Providers.AzureOpenAi": {
        "enum": [
          "azure-openai"
        ],
        "type": "string"
      },
      "AzureOpenAi_tts_provider": {
        "properties": {
          "voice_id": {
            "type": "string",
            "description": "Voice ID selected from the list of available voices.</br>Retrieve available options from the GET /voices endpoint.",
            "example": "en-US-JennyNeural"
          },
          "voice_config": {
            "$ref": "#/components/schemas/VoiceConfigMicrosoft",
            "description": "Voice customization options"
          },
          "language": {
            "type": "string",
            "description": "Voice customization options. To save the language of the selected agent voice",
            "example": "English (United States)"
          },
          "type": {
            "$ref": "#/components/schemas/Providers.AzureOpenAi"
          }
        },
        "required": [
          "voice_id",
          "type"
        ],
        "type": "object",
        "additionalProperties": false,
        "title": "OpenAI"
      },
      "TextToSpeechProviders": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/Microsoft_tts_provider"
          },
          {
            "$ref": "#/components/schemas/Elevenlabs_tts_provider"
          },
          {
            "$ref": "#/components/schemas/Amazon_tts_provider"
          },
          {
            "$ref": "#/components/schemas/Google_tts_provider"
          },
          {
            "$ref": "#/components/schemas/AzureOpenAi_tts_provider"
          }
        ],
        "title": "Text to Speech Providers"
      },
      "AudioUrl": {
        "type": "string",
        "example": "https://path.to/audio.mp3",
        "pattern": "^(https|s3):\\/\\/[\\S]+\\.(?:m4a|M4A|flac|FLAC|mp3|MP3|mp4|MP4|wav|WAV)([?#][\\w.\\/=&#%-]+)?$"
      },
      "Script": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/TextScript3"
          },
          {
            "$ref": "#/components/schemas/AudioScript3"
          }
        ]
      },
      "Logo": {
        "properties": {
          "url": {
            "type": "string",
            "description": "https url to an ARGB jpg/png image, a default logo is used otherwise",
            "pattern": "((https|s3):\\/\\/.+)"
          },
          "position": {
            "items": {
              "type": "integer",
              "format": "int32"
            },
            "type": "array",
            "description": "position of the logo in pixels from the top left corner (w,h) negative values are subtracted from last pixel",
            "example": [
              0,
              500
            ],
            "minItems": 2,
            "maxItems": 2
          }
        },
        "required": [
          "url",
          "position"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "UseLogo": {
        "type": "boolean"
      },
      "ExpressiveStatus": {
        "enum": [
          "created",
          "done",
          "error",
          "started",
          "rejected"
        ],
        "type": "string"
      },
      "Pick_ExpressiveVideo.id-or-status-or-created_at_": {
        "properties": {
          "id": {
            "type": "string",
            "description": "The id of the expressive video"
          },
          "status": {
            "$ref": "#/components/schemas/ExpressiveStatus"
          },
          "created_at": {
            "type": "string",
            "description": "The date the video was created",
            "example": "2021-01-01T00:00:00.000Z"
          }
        },
        "required": [
          "id",
          "status",
          "created_at"
        ],
        "type": "object",
        "description": "From T, pick a set of properties whose keys are in the union K"
      },
      "CreateExpressiveResponseDto": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Pick_ExpressiveVideo.id-or-status-or-created_at_"
          },
          {
            "properties": {
              "object": {
                "type": "string",
                "enum": [
                  "expressive"
                ],
                "nullable": false
              }
            },
            "required": [
              "object"
            ],
            "type": "object"
          }
        ]
      },
      "ExpressiveVideoConfig": {
        "properties": {
          "logo": {
            "anyOf": [
              {
                "$ref": "#/components/schemas/Logo"
              },
              {
                "$ref": "#/components/schemas/UseLogo"
              }
            ]
          },
          "result_format": {
            "type": "string",
            "enum": [
              "mp4",
              "mov",
              "webm"
            ],
            "description": "The file format of the result. If result_url is provided, result_format must match the format of the result_url.\nwebm cannot be combined with output_resolution 2160.",
            "example": "mp4"
          },
          "output_resolution": {
            "type": "number",
            "enum": [
              480,
              720,
              1080,
              2160
            ],
            "description": "The output resolution of the video (height in pixels, 16:9 aspect ratio).\nAllowed values: 480 (SD), 720 (HD), 1080 (Full HD), 2160 (4K).\n2160 requires a 4k avatar and is not supported with the webm result format.",
            "default": 1080
          }
        },
        "type": "object",
        "additionalProperties": false
      },
      "ColorBackground": {
        "properties": {
          "type": {
            "type": "string",
            "enum": [
              "color"
            ],
            "nullable": false
          },
          "value": {
            "type": "string",
            "example": "#47ffff",
            "pattern": "^#[a-fA-F0-9]{6}$"
          }
        },
        "required": [
          "type",
          "value"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "ExpressiveImageUrl": {
        "type": "string",
        "pattern": "^(?:https|s3):\\/\\/[\\S]+$"
      },
      "ExpressiveImageBackground": {
        "properties": {
          "type": {
            "type": "string",
            "enum": [
              "image_url"
            ],
            "nullable": false
          },
          "value": {
            "$ref": "#/components/schemas/ExpressiveImageUrl",
            "example": "https://path.to.image/"
          }
        },
        "required": [
          "type",
          "value"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "TransparentBackground": {
        "properties": {
          "type": {
            "type": "string",
            "enum": [
              "transparent"
            ],
            "nullable": false
          },
          "value": {
            "type": "boolean",
            "enum": [
              true
            ],
            "nullable": false
          }
        },
        "required": [
          "type",
          "value"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "ExpressiveVideoBackground": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/ColorBackground"
          },
          {
            "$ref": "#/components/schemas/ExpressiveImageBackground"
          },
          {
            "$ref": "#/components/schemas/TransparentBackground"
          }
        ]
      },
      "TextScript3": {
        "properties": {
          "type": {
            "type": "string",
            "enum": [
              "text"
            ],
            "nullable": false,
            "description": "The type of the script."
          },
          "subtitles": {
            "type": "boolean",
            "description": "Should subtitles be created.",
            "default": false
          },
          "provider": {
            "$ref": "#/components/schemas/TextToSpeechProviders",
            "description": "text-to-speech provider from list of supported providers. default is microsoft tts"
          },
          "input": {
            "type": "string",
            "description": "The input text that will be synthesized to an audio file.\nNote that each provider has its own limitations on the text length.\nMaximum 40K characters (10K excluding SSML tags).",
            "example": "Making videos is easy with D-ID",
            "default": "Making videos is easy with D-ID",
            "maxLength": 40000,
            "minLength": 3
          },
          "ssml": {
            "type": "boolean",
            "description": "Is the text provided in ssml form.",
            "default": false
          },
          "dictionary_id": {
            "type": "string",
            "description": "Pronunciation dictionary ID for word/phrase substitutions before TTS.",
            "example": "dict_V1StGXR8_Z5jdHi6B-myT",
            "pattern": "^dict_[A-Za-z0-9_-]{21}$"
          }
        },
        "required": [
          "type"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "AudioScript3": {
        "properties": {
          "type": {
            "type": "string",
            "enum": [
              "audio"
            ],
            "nullable": false,
            "description": "The type of the script."
          },
          "subtitles": {
            "type": "boolean",
            "description": "Should subtitles be created.",
            "default": false
          },
          "audio_url": {
            "$ref": "#/components/schemas/AudioUrl",
            "description": "The URL of the audio file which will be used by the actor.\nFile size is limited to 15MB.\nAudio length is limited 5 minutes for clips and 10 minutes for talks."
          }
        },
        "required": [
          "type",
          "audio_url"
        ],
        "type": "object",
        "additionalProperties": false
      },
      "Flatten_Pick_ExpressiveVideo.avatar_id-or-sentiment_id-or-name-or-config-or-background-or-user_data-or-persist-or-result_url-or-webhook-or-internal_call_config_-and-_script-Script__": {
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the video",
            "example": "my_expressive_video"
          },
          "avatar_id": {
            "type": "string",
            "description": "The id of the avatar of the video",
            "example": "public_dan@abcefg"
          },
          "sentiment_id": {
            "type": "string",
            "description": "The chosen sentiment id of the video",
            "example": "snt_IIjpTS"
          },
          "config": {
            "$ref": "#/components/schemas/ExpressiveVideoConfig"
          },
          "background": {
            "$ref": "#/components/schemas/ExpressiveVideoBackground"
          },
          "user_data": {
            "type": "string"
          },
          "persist": {
            "type": "boolean"
          },
          "result_url": {
            "type": "string",
            "description": "The result url of the video. Cannot be provided together with config.result_format.",
            "example": "https://example.com/result.mp4"
          },
          "webhook": {
            "type": "string"
          },
          "script": {
            "$ref": "#/components/schemas/Script"
          }
        },
        "required": [
          "avatar_id",
          "script"
        ],
        "type": "object",
        "description": "Flattens intersection types into a single object type.\nThis is useful for improving validation error messages and type display."
      }
    },
    "securitySchemes": {
      "basic": {
        "type": "http",
        "scheme": "basic"
      }
    }
  },
  "x-readme": {
    "samples-languages": [
      "curl"
    ]
  }
}
```